
import time
import optparse
import urllib2, httplib

class HTTPSClientAuthHandler(urllib2.HTTPSHandler):  
    def __init__(self, key, cert):  
        urllib2.HTTPSHandler.__init__(self)  
        self.key = key  
        self.cert = cert  
    def https_open(self, req):  
        #Rather than pass in a reference to a connection class, we pass in  
        # a reference to a function which, for all intents and purposes,  
        # will behave as a constructor  
        return self.do_open(self.getConnection, req)  
    def getConnection(self, host, timeout=300):  
        return httplib.HTTPSConnection( host,
                                        key_file=self.key,
                                        cert_file=self.cert )
                                        
class OptionParser (optparse.OptionParser):
    def check_required (self, opt):
        option = self.get_option(opt)
        # Assumes the option's 'default' is set to None!
        if getattr(self.values, option.dest) is None:
            self.error("%s option not supplied" % option)
            
class Timer:
    def __init__(self):
        self._times = []
        self._tstart = time.time()

    def logTime(self, tag=""):
        self._times.append("%s%.2f" % (tag, time.time() - self._tstart))
        self._tstart = time.time()

    def resetTimer(self):
        self._tstart = time.time()

    def getTimes(self):
        return self._times

    def printTimes(self):
        print "Times:\n" + "\n".join(self._times)
            
class MyGetter:
    def __init__(self, protocol, host, url):
        self._protocol = protocol
        self._hosturl = "%s://%s%s" % (protocol, host, url)
        self._hostcert = None
        self._hostkey = None
        
    def setHostCert(self, hc):
        self._hostcert = hc
        
    def setHostKey(self, hk):
        self._hostkey = hk
        
    def get(self):
        try:
            if self._hostcert and self._hostkey and self._protocol == "https":
                opener = urllib2.build_opener( \
                            HTTPSClientAuthHandler('%s' % self._hostkey,
                                                         '%s' % self._hostcert) )
                return opener.open(self._hosturl)
            else:
                return urllib2.urlopen(urllib2.Request(self._hosturl))
        except urllib2.URLError, e:
            return None
